Kea: isc::yang::TranslatorOptionData Class Reference

| Kea 3.2.0-git

isc::yang::TranslatorOptionData Class Reference

Option data translation between YANG and JSON. More...

`#include <translator_option_data.h>`

Inheritance diagram for isc::yang::TranslatorOptionData:
[legend]

## Public Member Functions
| TranslatorOptionData (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorOptionData ()=default
| Destructor.
isc::data::ElementPtr | getOptionData (libyang::DataNode const &data_node)
| Translate an option data from YANG to JSON.
isc::data::ElementPtr | getOptionDataFromAbsoluteXpath (std::string const &xpath)
| Translate an option data from YANG to JSON.
void | setOptionData (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set option data from JSON to YANG.
Public Member Functions inherited from isc::yang::Translator
| Translator (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~Translator ()=default
| Destructor.
template<typename T>
void | checkAndGet (isc::data::ElementPtr const &storage, libyang::DataNode const &data_node, std::string const &xpath, T translate) const
| Calls {translate} for the element found at {xpath} relative to {data_node} and sets the result in {storage} with the {xpath} key.
void | checkAndGetAndJsonifyLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, const std::string &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node, converts it from string to JSON and stores it in the specified storage.
template<typename T>
void | checkAndGetDiverging (isc::data::ElementPtr const &storage, libyang::DataNode const &data_node, std::string const &key, std::string const &xpath, T translate) const
| Calls {translate} for the element found at {xpath} relative to {data_node} and sets the result in {storage} with the {key} key.
void | checkAndGetDivergingLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name, std::string const &yang_name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
void | checkAndGetLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
void | checkAndSetDivergingLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, std::string const &yang_name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndSetLeafList (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath as a leaf-list.
void | checkAndSetUserContext (isc::data::ConstElementPtr const &from, std::string const &xpath)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndStringifyAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | deleteItem (const std::string &xpath)
| Delete basic value from YANG.
libyang::DataNode | findXPath (std::string const &xpath) const
| Retrieves a YANG data node by xpath.
template<typename functor_t>
void | forAll (std::string const &xpath, functor_t f) const
| Run a function for a node and all its children.
std::optional< libyang::DataNode > | getData (std::string const &xpath) const
| Get a YANG data node found at the given absolute xpath.
isc::data::ElementPtr | getItem (libyang::DataNode const &data_node, std::string const &xpath) const
| Translate a basic value from YANG to JSON for a given xpath that is relative to the given source node.
isc::data::ElementPtr | getItemFromAbsoluteXpath (std::string const &xpath) const
| Translate a basic value from YANG to JSON for a given absolute xpath.
template<typename T>
isc::data::ElementPtr | getList (libyang::DataNode const &data_node, std::string const &xpath, T &t, isc::data::ElementPtr(T::*f)(libyang::DataNode const &)) const
| Retrieve a list as ElementPtr from sysrepo from a certain xpath.
void | getMandatoryDivergingLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name, std::string const &yang_name) const
| Retrieves a child YANG data node identified by one name from the given parent YANG container node and stores it in the specified storage under a different name.
void | getMandatoryLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
bool | schemaNodeExists (std::string const &xpath) const
| Checks whether a YANG node exists in the schema.
void | setItem (const std::string &xpath, isc::data::ConstElementPtr const elem, libyang::LeafBaseType const type)
| Translate and set basic value from JSON to YANG.
void | setMandatoryDivergingLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, std::string const &yang_name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | setMandatoryLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.

## Protected Member Functions
isc::data::ElementPtr | getOptionDataKea (libyang::DataNode const &data_node)
| getOptionData JSON for kea-dhcp[46].
void | setOptionDataKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setOptionData for kea-dhcp[46].

## Additional Inherited Members
Static Public Member Functions inherited from isc::yang::Translator
static isc::data::ElementPtr | translateFromYang (std::optional< libyang::DataNode > data_node)
| Translate basic value from the given YANG data node to JSON element.
static std::optional< std::string > | translateToYang (isc::data::ConstElementPtr const &elem, libyang::LeafBaseType const type)
| Translate basic value from JSON to YANG.
Protected Types inherited from isc::yang::Translator
using | Deserializer
| Maps YANG types to functions that transform a YANG type into an ElementPtr.
using | Serializer
| Maps YANG types to functions that transform the string representation of an Element into a string that can be passed into Session::setItem().
Static Protected Member Functions inherited from isc::yang::Translator
static std::string | decode64 (std::string const &input)
| Decode a YANG element of binary type to a string that can be stored in an Element::string JSON.
static std::string | encode64 (std::string const &input)
| Encode a string such that it can be stored in a YANG element of binary type.
static Deserializer | initializeDeserializer ()
| Initializes the deserializer which is used to translate a YANG node to an ElementPtr.
static Serializer | initializeSerializer ()
| Initializes the serializer which is used to translate the string value of an Element to a string that can be passed into Session::setItem().
Protected Attributes inherited from isc::yang::Translator
std::string | model_
| The model.
sysrepo::Session | session_
| The sysrepo session.

## Detailed Description

Option data translation between YANG and JSON.

JSON syntax for Kea DHCP with command channel is:

{
"code": <code>,
"name": <name>,
"space": <space>,
"csv-format": <csv format flag>,
"data": <value>,
"always-send": <always send flag>,
"never-send": <never send flag>,
"user-context": { <json map> },
"comment": "<comment>"
}

YANG syntax for kea-dhcp[46] with code and space as keys is:

+--rw option-data* [code space]
+--rw code uint8
+--rw space string
+--rw name? string
+--rw data? string
+--rw csv-format? boolean
+--rw always-send? boolean
+--rw never-send? boolean
+--rw user-context? user-context
isc::data
Definition base_stamped_element.cc:12

An example in JSON and YANG formats:

[
{
"code": 100,
"space": "dns",
"csv-format": false,
"data": "12121212",
"always-send": false,
"never-send": false
}
]
/kea-dhcp6-server:config (container)
/kea-dhcp6-server:config/
option-data[code='100'][space='dns'][data='12121212'] (list instance)
/kea-dhcp6-server:config/
option-data[code='100'][space='dns'][data='12121212']/code = 100
/kea-dhcp6-server:config/
option-data[code='100'][space='dns'][data='12121212']/space = dns
/kea-dhcp6-server:config/
option-data[code='100'][space='dns'][data='12121212']/csv-format = false
/kea-dhcp6-server:config/
option-data[code='100'][space='dns'][data='12121212']/always-send = false
/kea-dhcp6-server:config/
option-data[code='100'][space='dns'][data='12121212']/never-send = false
isc::config
Definition command_interpreter.cc:23
isc::dns
Definition char_string.cc:26

A translator class for converting an option data between YANG and JSON.

Currently supports on kea-dhcp[46]-server, not yet ietf-dhcpv6-server.

Definition at line 78 of file translator_option_data.h.

## Constructor & Destructor Documentation

## ◆ TranslatorOptionData()

isc::yang::TranslatorOptionData::TranslatorOptionData | ( | sysrepo::Session | session,
|  | const std::string & | model )

Constructor.

Parameters

  session | Sysrepo session.
  model | Model name.

Definition at line 22 of file translator_option_data.cc.

References isc::yang::Translator::Translator().

Referenced by isc::yang::TranslatorOptionDataList::TranslatorOptionDataList().

Here is the call graph for this function:

## ◆ ~TranslatorOptionData()

virtual isc::yang::TranslatorOptionData::~TranslatorOptionData | ( |  | ) |
| virtualdefault

Destructor.

## Member Function Documentation

## ◆ getOptionData()

ElementPtr isc::yang::TranslatorOptionData::getOptionData | ( | libyang::DataNode const & | data_node | ) |

Translate an option data from YANG to JSON.

Parameters

  data_node | the YANG node representing the option data

Returns
  the JSON representation of the option data

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 28 of file translator_option_data.cc.

References getOptionDataKea(), isc_throw, isc::yang::Translator::model_, and isc::Exception::what().

Referenced by getOptionDataFromAbsoluteXpath(), and isc::yang::TranslatorOptionDataList::getOptionDataListKea().

Here is the call graph for this function:

## ◆ getOptionDataFromAbsoluteXpath()

ElementPtr isc::yang::TranslatorOptionData::getOptionDataFromAbsoluteXpath | ( | std::string const & | xpath | ) |

Translate an option data from YANG to JSON.

Parameters

  xpath | The xpath of the option data.

Returns
  JSON representation of the option data.

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 44 of file translator_option_data.cc.

References isc::yang::Translator::findXPath(), and getOptionData().

Here is the call graph for this function:

## ◆ getOptionDataKea()

ElementPtr isc::yang::TranslatorOptionData::getOptionDataKea | ( | libyang::DataNode const & | data_node | ) |
| protected

getOptionData JSON for kea-dhcp[46].

Parameters

  data_node | the YANG node representing the option data

Returns
  JSON representation of the option data.

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 53 of file translator_option_data.cc.

References isc::yang::Translator::checkAndGetAndJsonifyLeaf(), isc::yang::Translator::checkAndGetLeaf(), Element::createMap(), isc::yang::Translator::getItem(), and isc::yang::Translator::getMandatoryLeaf().

Referenced by getOptionData().

Here is the call graph for this function:

## ◆ setOptionData()

void isc::yang::TranslatorOptionData::setOptionData | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )

Translate and set option data from JSON to YANG.

Parameters

  xpath | The xpath of the option data.
  elem | The JSON element.

Definition at line 78 of file translator_option_data.cc.

References isc_throw, isc::yang::Translator::model_, setOptionDataKea(), and isc::Exception::what().

Referenced by isc::yang::TranslatorOptionDataList::setOptionDataListKea().

Here is the call graph for this function:

## ◆ setOptionDataKea()

void isc::yang::TranslatorOptionData::setOptionDataKea | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )
| protected

setOptionData for kea-dhcp[46].

Parameters

  xpath | The xpath of the option data.
  elem | The JSON element.

Definition at line 97 of file translator_option_data.cc.

References isc::yang::Translator::checkAndSetLeaf(), isc::yang::Translator::checkAndSetLeafList(), isc::yang::Translator::checkAndSetUserContext(), and isc::yang::Translator::setItem().

Referenced by setOptionData().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- translator_option_data.h
- translator_option_data.cc